UM .NET API 6.17.1

- Main Page
- Related Pages
- Packages
- Classes

- Class List
- Class Hierarchy
- Class Members

Classes | Public Member Functions | List of all members
com.latencybusters.lbm.LBMContextAttributes Class Reference

Encapsulates the set of default LBM context attributes. More...

Inheritance diagram for com.latencybusters.lbm.LBMContextAttributes:

## Classes
struct | lbm_resolver_event_func_t
struct | lbm_src_cost_func_t
struct | lbm_transport_mapping_func_t
struct | lbm_ume_ctx_rcv_ctx_notification_func_t
class | ume_rcv_liveness_notification_info

## Public Member Functions
unsafe | LBMContextAttributes ()
| Instantiate an LBMContextAttributes class. More...
unsafe | LBMContextAttributes (string contextName)
| Instantiate an LBMContextAttributes class using a context name from the xml configuration that must have been previously loaded. Use an empty string ("") to match a context without a name. More...
void | Dispose ()
| Free memory associated with this set of attributes.
void | dispose ()
| Free memory associated with this set of attributes (same as Dispose()). More...
unsafe void | setFromXml (string contextName)
| Set values in an LBMContextAttributes class using a context name from the xml configuration that must have been previously loaded. Use an empty string ("") to match a context without a name. More...
unsafe List< LBMConfigOption > | dumpAttributeList ()
| Returns an array of context attributes in LBConfigOption. More...
unsafe string | getValue (string attributeName)
| Returns the current value of an attribute from this set of context attributes. More...
unsafe void | setValue (string attributeName, string attributeValue)
| Set the current value of an attribute in this set of context attributes. More...
void | setSourceNotification (LBMSourceNotification cb, object cbarg)
| Set the callback and token to be used for source notifications. More...
void | clearSourceNotification ()
| Clear the currently stored source notification callback and token.
void | enableSourceNotification ()
| Enable new source notifications. More...
void | disableSourceNotification ()
| Disable new source notifications. More...
void | setResolverEventCallback (LBMResolverEventCallback cb, object cbArg)
| Set the context event callback for an LBMContext. More...
void | setResolverEventCallback (LBMResolverEventCallback cb)
| Set the context event callback for an LBMContext. More...
void | setSourceCostCallback (LBMSourceCostCallback cb)
| Set the source cost callback function for an LBMContext, which is an application callback to evaluate the cost of a newly discovered source. More...
void | setSourceCostCallback (LBMSourceCostCallback cb, object cbArg)
| Set the source cost callback function for an LBMContext, which is an application callback to evaluate the cost of a newly discovered source. More...
void | setTransportMappingCallback (LBMTransportMappingCallback cb)
| Set the transport mapping callback function for an LBMContext. More...
void | setTransportMappingCallback (LBMTransportMappingCallback cb, object cbArg)
| Set the transport mapping callback function for an LBMContext. More...
void | setContextSourceEventCallback (LBMContextSourceEventCallback cb)
| Set the context-level source event callback for an LBMContext. More...
void | setContextSourceEventCallback (LBMContextSourceEventCallback cb, LBMEventQueue evq)
| Set the context-level source event callback for an LBMContext. More...
void | setContextSourceEventCallback (LBMContextSourceEventCallback cb, object cbArg)
| Set the context-level source event callback for an LBMContext. More...
void | setContextSourceEventCallback (LBMContextSourceEventCallback cb, object cbArg, LBMEventQueue evq)
| Set the context-level source event callback for an LBMContext. More...
void | setContextEventCallback (LBMContextEventCallback cb)
| Set the context event callback for an LBMContext. More...
void | setContextEventCallback (LBMContextEventCallback cb, object cbArg)
| Set the context event callback for an LBMContext. More...
void | setContextEventCallback (LBMContextEventCallback cb, object cbArg, LBMEventQueue evq)
| Set the context event callback for an LBMContext. More...
void | setImmediateMessageCallback (LBMImmediateMessageCallback cb)
| Set (and enable) the context callback for topic-less immediate mode messages. More...
void | setImmediateMessageCallback (LBMImmediateMessageCallback cb, LBMEventQueue evq)
| Set (and enable) the context callback for topic-less immediate mode messages. More...
void | setImmediateMessageCallback (LBMImmediateMessageCallback cb, object cbArg)
| Set (and enable) the context callback for topic-less immediate mode messages. More...
void | setImmediateMessageCallback (LBMImmediateMessageCallback cb, object cbArg, LBMEventQueue evq)
| Set (and enable) the context callback for topic-less immediate mode messages. More...
void | setUMEReceiverLivenessNotificationCallbacks (UMEReceiverLivenessCreationCallback creationCb, UMEReceiverLivenessDeletionCallback deletionCb, object cbArg)
| Set per receiver context liveness detection creation and deletion notification callback functions. More...
void | setObjectRecycler (LBMObjectRecyclerBase objRec, Object objRecCbArg)
| Set the LBM object recycler that can be used by the context to reuse LBMMessage objects as well as LBM Context/Receiver/Source Statistics objects. More...

## Detailed Description

Encapsulates the set of default LBM context attributes.

## Constructor & Destructor Documentation

unsafe com.latencybusters.lbm.LBMContextAttributes.LBMContextAttributes | ( |  | ) |

Instantiate an LBMContextAttributes class.

Exceptions

  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

References com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

unsafe com.latencybusters.lbm.LBMContextAttributes.LBMContextAttributes | ( | string | contextName | ) |

Instantiate an LBMContextAttributes class using a context name from the xml configuration that must have been previously loaded. Use an empty string ("") to match a context without a name.

Parameters

  contextName | Context name string. Is written into the attributes object.

Exceptions

  com.latencybusters.lbm.LBMException | The contextName is not permitted by the XML configuration, or other unexpected operational behavior has been encountered by unmanaged LBM C layer function.

References com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

## Member Function Documentation

void com.latencybusters.lbm.LBMContextAttributes.disableSourceNotification | ( |  | ) |

Disable new source notifications.

See also
  enableSourceNotification

References com.latencybusters.lbm.LBMContextEventCallback(), com.latencybusters.lbm.LBMContextSourceEventCallback(), com.latencybusters.lbm.LBMImmediateMessageCallback(), com.latencybusters.lbm.LBMResolverEventCallback(), com.latencybusters.lbm.LBMSourceCostCallback(), com.latencybusters.lbm.LBMSourceNotification(), and com.latencybusters.lbm.LBMTransportMappingCallback().

void com.latencybusters.lbm.LBMContextAttributes.dispose | ( |  | ) |

Free memory associated with this set of attributes (same as Dispose()).

See also
  Dispose

References com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

unsafe List<LBMConfigOption> com.latencybusters.lbm.LBMContextAttributes.dumpAttributeList | ( |  | ) |

Returns an array of context attributes in LBConfigOption.

Exceptions

  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

Returns
  Returns an array of context attributes in LBConfigOption

References com.latencybusters.lbm.LBM.errorMessage(), com.latencybusters.lbm.LBM.errorNumber(), com.latencybusters.lbm.LBMConfigOption.OptionName, com.latencybusters.lbm.LBMConfigOption.Type, and com.latencybusters.lbm.LBMConfigOption.Value.

void com.latencybusters.lbm.LBMContextAttributes.enableSourceNotification | ( |  | ) |

Enable new source notifications.

New source notifications are delivered via the source notification callback set by LBMContext.addSourceNotifyCallback.

See also
  LBMContext.addSourceNotifyCallback
  disableSourceNotification

unsafe string com.latencybusters.lbm.LBMContextAttributes.getValue | ( | string | attributeName | ) |

Returns the current value of an attribute from this set of context attributes.

Parameters

  attributeName | Name of the attribute to retrieve

Exceptions

  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

Returns
  Value corresponding to the specified attribute name

References com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

void com.latencybusters.lbm.LBMContextAttributes.setContextEventCallback | ( | LBMContextEventCallback | cb | ) |

Set the context event callback for an LBMContext.

Parameters

  cb | A delegate of type LBMContextEventCallback

void com.latencybusters.lbm.LBMContextAttributes.setContextEventCallback | ( | LBMContextEventCallback | cb,
|  | object | cbArg
| ) |  |

Set the context event callback for an LBMContext.

Parameters

  cb | A delegate of type LBMContextEventCallback
  cbArg | A token to be passed in to the callback when an event occurs

void com.latencybusters.lbm.LBMContextAttributes.setContextEventCallback | ( | LBMContextEventCallback | cb,
|  | object | cbArg,
|  | LBMEventQueue | evq
| ) |  |

Set the context event callback for an LBMContext.

Parameters

  cb | A delegate of type LBMContextEventCallback
  cbArg | A token to be passed in to the callback when an event occurs
  evq | An event queue used to hold context events until the application is ready to process them

void com.latencybusters.lbm.LBMContextAttributes.setContextSourceEventCallback | ( | LBMContextSourceEventCallback | cb | ) |

Set the context-level source event callback for an LBMContext.

Parameters

  cb | LBMContextSourceEventCallback callback delegate.

void com.latencybusters.lbm.LBMContextAttributes.setContextSourceEventCallback | ( | LBMContextSourceEventCallback | cb,
|  | LBMEventQueue | evq
| ) |  |

Set the context-level source event callback for an LBMContext.

Parameters

  cb | LBMContextSourceEventCallback callback delegate.
  evq | LBMEventQueue on which to place context-level source events (can be null).

void com.latencybusters.lbm.LBMContextAttributes.setContextSourceEventCallback | ( | LBMContextSourceEventCallback | cb,
|  | object | cbArg
| ) |  |

Set the context-level source event callback for an LBMContext.

Parameters

  cb | LBMContextSourceEventCallback callback delegate.
  cbArg | Callback object.

void com.latencybusters.lbm.LBMContextAttributes.setContextSourceEventCallback | ( | LBMContextSourceEventCallback | cb,
|  | object | cbArg,
|  | LBMEventQueue | evq
| ) |  |

Set the context-level source event callback for an LBMContext.

Parameters

  cb | LBMContextSourceEventCallback callback delegate.
  cbArg | Callback object.
  evq | LBMEventQueue on which to place context-level source events (can be null).

unsafe void com.latencybusters.lbm.LBMContextAttributes.setFromXml | ( | string | contextName | ) |

Set values in an LBMContextAttributes class using a context name from the xml configuration that must have been previously loaded. Use an empty string ("") to match a context without a name.

Parameters

  contextName | Context name string. Is written into the attributes object.

Exceptions

  com.latencybusters.lbm.LBMException | The contextName is not permitted by the XML configuration, or other unexpected operational behavior has been encountered by unmanaged LBM C layer function.

References com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

void com.latencybusters.lbm.LBMContextAttributes.setImmediateMessageCallback | ( | LBMImmediateMessageCallback | cb | ) |

Set (and enable) the context callback for topic-less immediate mode messages.

Parameters

  cb | LBMImmediateMessageCallback callback delegate.

void com.latencybusters.lbm.LBMContextAttributes.setImmediateMessageCallback | ( | LBMImmediateMessageCallback | cb,
|  | LBMEventQueue | evq
| ) |  |

Set (and enable) the context callback for topic-less immediate mode messages.

Parameters

  cb | LBMImmediateMessageCallback callback delegate.
  evq | LBMEventQueue on which to place received topic-less immediate-mode messages (can be null).

void com.latencybusters.lbm.LBMContextAttributes.setImmediateMessageCallback | ( | LBMImmediateMessageCallback | cb,
|  | object | cbArg
| ) |  |

Set (and enable) the context callback for topic-less immediate mode messages.

Parameters

  cb | LBMImmediateMessageCallback callback delegate.
  cbArg | Callback object.

void com.latencybusters.lbm.LBMContextAttributes.setImmediateMessageCallback | ( | LBMImmediateMessageCallback | cb,
|  | object | cbArg,
|  | LBMEventQueue | evq
| ) |  |

Set (and enable) the context callback for topic-less immediate mode messages.

Parameters

  cb | LBMImmediateMessageCallback callback delegate.
  cbArg | Callback object.
  evq | LBMEventQueue on which to place received topic-less immediate-mode messages (can be null).

void com.latencybusters.lbm.LBMContextAttributes.setObjectRecycler | ( | LBMObjectRecyclerBase | objRec,
|  | Object | objRecCbArg
| ) |  |

Set the LBM object recycler that can be used by the context to reuse LBMMessage objects as well as LBM Context/Receiver/Source Statistics objects.

Parameters

  objRec | an LBM object recycler that will be called when objects need to be retrieved
  objRecCbArg | a callback object token that will be passed in the retrieve method

References com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

void com.latencybusters.lbm.LBMContextAttributes.setResolverEventCallback | ( | LBMResolverEventCallback | cb,
|  | object | cbArg
| ) |  |

Set the context event callback for an LBMContext.

Parameters

  cb | A delegate of type LBMResolverEventCallback
  cbArg | A token to be passed in to the callback when an event occurs

void com.latencybusters.lbm.LBMContextAttributes.setResolverEventCallback | ( | LBMResolverEventCallback | cb | ) |

Set the context event callback for an LBMContext.

Parameters

  cb | A delegate of type LBMResolverEventCallback

void com.latencybusters.lbm.LBMContextAttributes.setSourceCostCallback | ( | LBMSourceCostCallback | cb | ) |

Set the source cost callback function for an LBMContext, which is an application callback to evaluate the cost of a newly discovered source.

Parameters

  cb | LBMSourceCostCallback callback delegate

void com.latencybusters.lbm.LBMContextAttributes.setSourceCostCallback | ( | LBMSourceCostCallback | cb,
|  | object | cbArg
| ) |  |

Set the source cost callback function for an LBMContext, which is an application callback to evaluate the cost of a newly discovered source.

Parameters

  cb | LBMSourceCostCallback callback delegate
  cbArg | Callback object token

void com.latencybusters.lbm.LBMContextAttributes.setSourceNotification | ( | LBMSourceNotification | cb,
|  | object | cbarg
| ) |  |

Set the callback and token to be used for source notifications.

Parameters

  cb | The source notification callback
  cbarg | The callback object token

void com.latencybusters.lbm.LBMContextAttributes.setTransportMappingCallback | ( | LBMTransportMappingCallback | cb | ) |

Set the transport mapping callback function for an LBMContext.

Parameters

  cb | LBMTransportMappingCallback callback delegate

void com.latencybusters.lbm.LBMContextAttributes.setTransportMappingCallback | ( | LBMTransportMappingCallback | cb,
|  | object | cbArg
| ) |  |

Set the transport mapping callback function for an LBMContext.

Parameters

  cb | LBMTransportMappingCallback callback delegate
  cbArg | Callback object token

void com.latencybusters.lbm.LBMContextAttributes.setUMEReceiverLivenessNotificationCallbacks | ( | UMEReceiverLivenessCreationCallback | creationCb,
|  | UMEReceiverLivenessDeletionCallback | deletionCb,
|  | object | cbArg
| ) |  |

Set per receiver context liveness detection creation and deletion notification callback functions.

Parameters

  creationCb | UME Receiver Liveness creation callback delegate
  deletionCb | UME Reciever Liveness deletion callback delegate
  cbArg | Client-supplied callback object.

Exceptions

  com.latencybusters.lbm.LBMEInvalException | Both receiver liveness notification callbacks must be set or cleared at once.
  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer functions.

References com.latencybusters.lbm.LBM.EINVAL, com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

unsafe void com.latencybusters.lbm.LBMContextAttributes.setValue | ( | string | attributeName,
|  | string | attributeValue
| ) |  |

Set the current value of an attribute in this set of context attributes.

Parameters

  attributeName | Name of the attribute to set
  attributeValue | New attribute value

Exceptions

  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

References com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

The documentation for this class was generated from the following file:

- LBMContextAttributes.cs